from jugaad_trader import Zerodha
kite = Zerodha()
kite.set_access_token()
kws = kite.ticker()
 
import os 
import copy
import talib
import pandas_ta as pta
import time
import datetime
import xlwings as xw 
import pandas as pd 
import numpy as np 
import time 
import dateutil.parser 
import datetime  
 
try :
    kite.margins()
except : 
    print ( " Login Failed !!!! " ) 
if not os.path.exists("Easy_Algo.xlsx"): 
    try :
        wb = xw.Book() 
        wb.sheets.add("margins")
        wb.sheets.add("orderbook")
        wb.sheets.add("Trading") 
        wb.sheets.add("Optionchain")
        wb.save("Easy_Algo.xlsx") 
        wb.close() 
    except Exception as e : 
        print(f"Error creating Excel File:{e}") 
        sys.exit() 
wb = xw.Book("Easy_Algo.xlsx") 
oc = wb.sheets("Optionchain") 
ts = wb.sheets['Trading']
orderbook = wb.sheets['orderbook']
margins = wb.sheets['margins']
ts.range('A1').value = 'Stock_Name'
watchlist =  ts.range('A2').expand().value
def send_indicator():
    global ts 
    lis = []
    watchlist = ts.range('A2').expand().value
    for name in watchlist:
        timeframe_number_to_char = {'1':"minute",   '365':"day",    '3':"3minute",  '5':"5minute",  '10':"10minute",    '15':"15minute",    '30':"30minute",    '60':"60minute"}
        #timeframe_string = timeframe_number_to_char[timeframe]
        token = kite.ltp(['NSE:'+name])['NSE:'+name]['instrument_token']
        to_date = datetime.datetime.now().date()
        from_date = to_date - datetime.timedelta(days=4)
        data = kite.historical_data(token, from_date, to_date, '5minute')
        df = pd.DataFrame(data)
        df['rsi14'] = talib.RSI(df['close'], timeperiod=14)
        df['ema_10'] = talib.EMA(df['close'], timeperiod = 10)
        df['ema_20'] = talib.EMA(df['close'], timeperiod = 20 )
        df['ema_50'] = talib.EMA(df['close'], timeperiod = 50 )
        df['sma_50'] = talib.SMA(df['close'] , timeperiod=50)
        st = pta.supertrend(high = df['high'] , low =df['low'] , close = df['close'] , length=2, multiplier=2, offset=None,)
        df['SUPERT_10_2'] = st['SUPERT_2_2.0']
        df['sma_75(rsi14)'] = talib.SMA(df['rsi14'] , timeperiod=75)
        df = df.tail(1)
        lis.append(df)
        df = pd.concat(lis, axis=0)
        df.set_index = df['date']
        df = df[['rsi14','ema_10','ema_20','ema_50','sma_50','SUPERT_10_2','sma_75(rsi14)']]
        ts.range('T1').value = df 
        print('send indicator data is runing ')
        watchlist =  ts.range('A2').expand().value
        stocks_list = []
        for i in watchlist:
            stocks_list.append(f"NSE:{i.upper()}")      
        ticks = kite.quote(stocks_list)     
        live_data = {}
        for k, v in ticks.items():
            live_data[k[4:]] = {"Open": v["ohlc"]["open"],
                                "High": v["ohlc"]["high"],
                                "Low": v["ohlc"]["low"],
                                "close": v["ohlc"]["close"],
                                "Ltp": v["last_price"],
                                "net_change": v["net_change"],
                                "Vwap": v["average_price"],
                                "Volume": v["volume"],
                                "oi": v["oi"],
                                "oi_day_high": v["oi_day_high"],
                                "oi_day_low": v["oi_day_low"]}      
        df = pd.DataFrame(live_data).transpose()
        ts.range('G1').value = df
        print('send stock data is runing ')
        ts = wb.sheets['Trading']
        end = len(watchlist) + 2
        for row_no in range(2, end):
            buy = ts.range( 'c' + str(row_no)).value
            sell = ts.range( 'd' + str(row_no)).value
            qty = ts.range( 'e' + str(row_no)).value
            remark = ts.range( 'f' + str(row_no)).value
            if (buy == "buy") and (remark is None):
                ts.range( 'f' + str(row_no)).value = "placed_buy_order"
            if (buy  is None) and (sell  is None):
                ts.range( 'f' + str(row_no)).value = None
            if (sell == "sell") and (remark is None):
                ts.range( 'f' + str(row_no)).value = "placed_sell_order"
            if (buy  is None) and (sell  is None):
                ts.range( 'f' + str(row_no)).value = None
        print('place_buy_sell is runing ')
    
    

